//
//    File: image.h
//
//    (C) 2000-2006 Helmut Cantzler
//
//    Licensed under the terms of the Lesser General Public License.
//

#ifndef _IMAGE_H
#define _IMAGE_H

#define MAX_WIDTH 4048
#define MAX_HEIGHT 4048

#include <qimage.h>

#include "array3d.h"

class Image
{
public:
  Image();
  ~Image();

  int read(const char *filename);
  void scale(int height, int width);

  int height(void) const;
  int width(void) const;

  const unsigned char* data(void);

private:
  Array3D<unsigned char> *image_data;
  QImage *image;
  int image_height, image_width;
};

#endif
